

$(function() {

    $.getJSON("/api/usercount", function(data, textStatus, jqXHR) {

        var offset = new Date().getTimezoneOffset();
        var newData = [];

        for (var i = 0; i < data.datapoints.length; i++) {
            var date = moment(data.datapoints[i].at).unix() - offset * 60;
            var value = parseFloat(data.datapoints[i].value);
            newData.push({x: date, y: value});
        }

        var graph = new Rickshaw.Graph( {
            element: document.querySelector("#graph"),
            renderer: 'bar',
            series: [ {
                data: newData,
                name: 'Benutzer',
                color: 'steelblue'
            } ]
        } );



        new Rickshaw.Graph.Axis.Time({graph: graph}).render();
        new Rickshaw.Graph.Axis.Y({graph: graph}).render();


        graph.render();

    });



});
